package conf

var ExampleFile = "http://localhost:8090/public/uploadxlsx/example.xlsx"

var Baseurl = "http://localhost:8090"

var Confurl = "conf/config.yaml"

type AppConf struct {
	DisablePathCorrection             bool
	EnablePathEscape                  bool
	FireMethodNotAllowed              bool
	DisableBodyConsumptionOnUnmarshal bool
	TimeFormat                        string
	Charset                           string
	Other                             Other
	PublicRute                        []string
}
type Other struct {
	IgnoreURLs []string
	JWTTimeout int64
	LogLevel   string
	Secret     string
}

var AppConfig AppConf = AppConf{
	DisablePathCorrection:             false,
	EnablePathEscape:                  false,
	FireMethodNotAllowed:              false,
	DisableBodyConsumptionOnUnmarshal: false,
	TimeFormat:                        "Mon, 01 Jan 2006 15:04:05 GMT",
	Charset:                           "UTF-8",
	Other: Other{
		IgnoreURLs: []string{"/", "/user/login", "/user/plants","/admin/tabnames/download","/user/getimg"},//免token验证路径
		JWTTimeout: 72000,
		LogLevel:   "debug",
		//Secret:     "LAPP_SJA_ONLINE_101146458",
		Secret:     "LAPP_SJA_TEST_101146419",
	},
	PublicRute: []string{"/sysMenu","/user/getuserinfo","/user/pwd","/user/avatar","/user/profile","/user/getimg","/admin/tabnames/list","/admin/me_project/selectall","/admin/pln_forecast_landing/selectall"},//免权限检查路径
}

