package db

import (
	"LAPP_SJA_ME/conf"
	"fmt"
	_ "github.com/denisenkom/go-mssqldb"
	"github.com/xormplus/xorm"
	"log"
	"testing"
)

func TestDb(t *testing.T) {
	var (
		engine *xorm.Engine
		err    error
	)

	c := conf.MasterDbConfig
	driveSource := fmt.Sprintf("server=%s;database=%s;user id=%s;password=%s;port=%d;encrypt=disable",
		c.Host, c.DbName, c.User, c.Pwd, c.Port)
	fmt.Print(driveSource)
	if engine, err = xorm.NewEngine(conf.DriverName, driveSource); err != nil {
		t.Error(err)
		return
	}
	//开启sql，debug
	engine.ShowSQL(true)
	if err = engine.Ping(); err != nil {
		log.Println("数据库连接失败:", driveSource, err.Error())
		return
	} else {
		log.Println("数据库连接成功：", driveSource)
	}
}
