package models

import "LAPP_SJA_ME/utils"

type Bomtab struct {
	Finr          int     `xorm:"pk comment('工厂号') Int" json:"bomtab-finr"`
	Artnr         string  `xorm:"pk comment('Id') VARCHAR(40)" json:"bomtab-artnr"`
	ProjNr        string  `xorm:"comment('描述') VARCHAR(18)" json:"bomtab-proj_nr"`
	Itemnr        string  `xorm:"comment('有效起始日期') VARCHAR(16)" json:"bomtab-itemnr"`
	Artqty        float64 `xorm:"comment('有效截至日期') Double" json:"bomtab-artqty"`
	Itemqty       float64 `xorm:"comment('前缀') Double" json:"bomtab-itemqty"`
	Qtyuom        string  `xorm:"comment('中缀') VARCHAR(40)" json:"bomtab-qtyuom"`
	Leadtimedays  float64 `xorm:"comment('后缀') Double" json:"bomtab-leadtimedays"`
	Lossrate      float64 `xorm:"comment('流水号起始值') Double" json:"bomtab-lossrate"`
	Backflushitem int     `xorm:"comment('流水号截止值') INT" json:"bomtab-backflushitem"`
	Criticalitem  int     `xorm:"comment('步幅') INT" json:"bomtab-criticalitem"`
	Validfrom     string  `xorm:"comment('序号重置规则') VARCHAR(10)" json:"bomtab-validfrom"`
	Validto       string  `xorm:"comment('序号溢出处理') VARCHAR(10)" json:"bomtab-validto"`
	Lastmodif     string  `xorm:"comment('最近一次更改时间') VARCHAR(14)" json:"bomtab-lastmodif"`
	Lastuser      string  `xorm:"comment('最近一次更改人') VARCHAR(20)" json:"bomtab-lastuser"`
	Credatuz      string  `xorm:"comment('创建时间') VARCHAR(14)" json:"bomtab-credatuz"`
}

func (t *Bomtab) TableName() string {
	return "bomtab"
}

// 清除string字段的右侧空格
func (t *Bomtab) Clipped() {
	utils.TrimStruct(t, *t)
}
