package models

import (
	"LAPP_SJA_ME/db"
	"LAPP_SJA_ME/utils"
	"fmt"
	"os"
	"testing"
)

// 测试TOD引擎
func TestLab(t *testing.T) {
	var (
		lab *LAB
		ediFile string
		err error
	)

	// 初始化
	lab = &LAB{}
	ediFile = "D:\\Go\\gopath\\src\\LAPP_SJA_ME\\doc\\BMW.SY78.DELINS.2020020213145377.B0213145"
	if err = ParseLabEdi(ediFile, lab); err != nil {
		t.Errorf("Failed to parse due to: %v", err)
	}
	PrintLabEdi(lab)
	fmt.Println("Total data rows = ", lab.DataRows)
	return
}


// 测试上传
func TestReadXlsx(t *testing.T) {
	savePath :=  utils.EnsureDir("web/public/uploadxlsx/TEST20200708171842157.xlsx")
	fmt.Printf("绝对路径是：%v",savePath)
	// 打开文件
	f, err := os.Open(savePath);
	if err != nil{
		t.Errorf("Failed to parse due to: %v", err)
	}
	defer f.Close()
}

// 测试工作日历
func TestSelectDate(t *testing.T) {
	t1 := "20200804"
	t2 := "20200901"
	data := utils.SelectDate(t1,t2)
	fmt.Printf("工作日历时间表:%v",data)
}

// 测试工作日历
func Test(t *testing.T) {
	m := PlnForecastHead{}
	m.Finr = 100
	m.Forecastid = "FC-000000010"
	m.Custplantnr = "SY78"
	engine := db.Eloquent.Master()

	//锁定解析，状态变成已经解析
	engine.Table("pln_forecast_head").Where("finr = ? and forecatid = ? and custplantnr = ?",m.Finr, m.Forecastid, m.Custplantnr).Update(map[string]interface{}{"status": "1"})
}
