package models

import (
	"LAPP_SJA_ME/db"
	"LAPP_SJA_ME/utils"
	"xorm.io/core"
	"errors"
)

//属性值主数据
type MeAttributeValst struct {
	Finr      int    `xorm:"pk comment('工厂号') int(0)" json:"me_attribute_valst-finr"`
	Attrcode  int    `xorm:"pk comment('属性ID') int(0)" json:"me_attribute_valst-attrcode"`
	Pos       int    `xorm:"pk comment('属性值位置号') int(0)" json:"me_attribute_valst-pos"`
	Attrvalue string `xorm:"comment('属性名') VARCHAR(40)" json:"me_attribute_valst-attrvalue"`
	Descr     string `xorm:"comment('描述1') VARCHAR(40)" json:"me_attribute_valst-descr"`
	Shortcode string `xorm:"comment('值短码') VARCHAR(40)" json:"me_attribute_valst-shortcode"`
	Valformat string `xorm:"comment('') VARCHAR(40)" json:"me_attribute_valst-valformat"`
	Lastmodif string `xorm:"comment('最近一次更改时间') VARCHAR(14)" json:"me_attribute_valst-lastmodif"`
	Lastuser  string `xorm:"comment('最近一次更改人') VARCHAR(20)" json:"me_attribute_valst-lastuser"`
	Credatuz  string `xorm:"comment('创建时间') VARCHAR(14)" json:"me_attribute_valst-credatuz"`
}

func (t *MeAttributeValst) TableName() string {
	return "me_attribute_valst"
}
// 清除string字段的右侧空格
func (t *MeAttributeValst) Clipped() {
	utils.TrimStruct(t, *t)
}
//增
func (t *MeAttributeValst) Add() error {
	e := db.Eloquent.Master()
	countrole := new(MeAttributeValst)
	affw, err := e.Table("me_attribute_valst").ID(core.PK{t.Finr,t.Attrcode,t.Pos}).Count(countrole)
	if err != nil {
		return  err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("me_attribute_valst").Insert(t)

	if err != nil {
		return  err
	}
	return nil
}
//删
func(t *MeAttributeValst) Del() bool{
	e := db.Eloquent.Master()
	_, err := e.ID(core.PK{t.Finr,t.Attrcode,t.Pos}).Delete(&MeAttributeValst{})
	if err !=nil{
		return false
	}
	return true
}
//改
func(t *MeAttributeValst)Update()bool{
	e := db.Eloquent.Master()
	_, err := e.ID(core.PK{t.Finr,t.Attrcode,t.Pos}).Update(t)
	if err !=nil{
		return false
	}
	return true
}
//查
func(t *MeAttributeValst)SelectOne() (MeAttributeValst,error){
	e := db.Eloquent.Master()
	var data MeAttributeValst
	_, err := e.ID(core.PK{t.Finr,t.Attrcode,t.Pos}).Get(&data)
	if err !=nil{
		return data,err
	}
	return data,nil
}
//分页
func (t *MeAttributeValst) GetPage(pageSize int, pageIndex int) ([]MeAttributeValst, int, error) {
	data := make([]MeAttributeValst, 0)
	e := db.Eloquent.Master()
	table := e.Table("me_attribute_valst").Where("finr = ? ",t.Finr)
	where := "where finr = "+ "'" + utils.ValueToString(t.Finr,"") + "'"
	if t.Attrcode > 0 {
		table = table.And("attrcode = ?", t.Attrcode)
		where += " and attrcode = " + "'" + utils.ValueToString(t.Attrcode,"") + "'"
	}
	Offset := (pageIndex - 1) * pageSize
	err := e.SQL("SELECT TOP " + utils.ValueToString(pageSize, "") + " me_attribute_valst.* FROM me_attribute_valst " + where + " AND (convert(varchar(10),finr)+convert(varchar(40),attrcode) NOT IN (SELECT TOP " + utils.ValueToString(Offset, "") + " convert(varchar(10),finr)+convert(varchar(40),attrcode) FROM me_attribute_valst " + where + " ORDER BY credatuz DESC)) ORDER BY credatuz DESC").Find(&data)
	pcount := new(MeAttributeValst)
	count, err := table.Count(pcount)
	if err != nil {
		return nil, 0, err
	}
	for k,_:=range data{
		data[k].Clipped()
	}
	return data, int(count), nil
}

//根据属性名查询所有的属性值
func(t *MeAttributeValst)SelectVal() ([]string,error){
	e := db.Eloquent.Master()
	var data []MeAttributeValst
	err := e.Where("finr = ? and attrcode = ?",t.Finr,t.Attrcode).Find(&data)
	if err !=nil{
		return nil,err
	}
	var strdata []string
	for _,v:=range data{
		v.Clipped()
		strdata = append(strdata,v.Attrvalue)
	}
	return strdata,nil
}