package models

import (
	"LAPP_SJA_ME/db"
	"LAPP_SJA_ME/utils"
	"fmt"
	"github.com/360EntSecGroup-Skylar/excelize"
)

//零件属性主数据
type MePartAtcodlst struct {
	Finr      int    `xorm:"pk comment('工厂号') int(0)" json:"me_part_atcodlst-finr"`
	Partid    string `xorm:"pk comment('零件Id') VARCHAR(40)" json:"me_part_atcodlst-partid"`
	Projnr    string `xorm:"pk comment('项目Id') VARCHAR(10)" json:"me_part_atcodlst-projnr"`
	Attrcode  int    `xorm:"pk comment('属性ID') int(0)" json:"me_part_atcodlst-attrcode"`
	Version   int    `xorm:"pk comment('版本号') int(0)" json:"me_part_atcodlst-version"`
	Attrvalue string `xorm:"comment('属性值') VARCHAR(40)" json:"me_part_atcodlst-attrvalue"`
	Lastmodif string `xorm:"comment('最近一次更改时间') VARCHAR(14)" json:"me_part_atcodlst-lastmodif"`
	Lastuser  string `xorm:"comment('最近一次更改人') VARCHAR(14)" json:"me_part_atcodlst-lastuser"`
	Credatuz  string `xorm:"comment('创建时间') VARCHAR(20)" json:"me_part_atcodlst-credatuz"`
}

func (t *MePartAtcodlst) TableName() string {
	return "me_part_atcodlst"
}

// 清除string字段的右侧空格
func (t *MePartAtcodlst) Clipped() {
	utils.TrimStruct(t, *t)
}

type KvMap struct {
	Attrcode int
	Val      string
}

//查询所有的零件属性
func (t *MePartAtcodlst) SelectData() ([]MePartAtcodlst, error) {
	e := db.Eloquent.Master()
	data := make([]MePartAtcodlst, 0)

	//查询所有属性
	err := e.Table("me_part_atcodlst").Where("finr = ? and version = ?", t.Finr, t.Version).Find(&data)
	if err != nil {
		return data, err
	}
	for k, _ := range data {
		data[k].Clipped()
	}
	return data, nil
}

//查询零件分配
func (t *MePartAtcodlst) SelectDataVal() ([]MePartAtcodlst, error) {
	e := db.Eloquent.Master()
	data := make([]MePartAtcodlst, 0)

	//查询所有属性
	err := e.Table("me_part_atcodlst").Where("finr = ? and version = ? and partid = ? and projnr = ?", t.Finr, t.Version, t.Partid, t.Projnr).Find(&data)
	if err != nil {
		return data, err
	}
	for k, _ := range data {
		data[k].Clipped()
	}
	return data, nil
}

//分页
func (t *MePartAtcodlst) GetPage(pageSize int, pageIndex int, partgroupid string, parts []string, modelAttrs []int,ishide bool,projectid string) ([]map[string]interface{}, int, error) {
	dataMap := make([]map[string]interface{}, 0)

	//查询出所有的属性
	var attr MeAttribute
	attr.Finr = t.Finr
	arr1 := make([]MeAttribute, 0)
	var err error
	if utils.ValueIsEmpty(modelAttrs) {
		arr1, err = attr.SelectData()
	} else {
		arr1, err = attr.SelectInData(modelAttrs)
	}
	if err != nil {
		return nil, 0, err
	}
	data := make([]MePart, 0)
	e := db.Eloquent.Master()
	table := e.Table("me_part")
	where := ""

	if !utils.ValueIsEmpty(partgroupid) {
		table = table.Join("left","me_partgroup_partlst", "me_partgroup_partlst.finr = me_part.finr and me_partgroup_partlst.partid = me_part.partid and me_partgroup_partlst.projnr" +
			" = me_part.projnr").Where("me_part.finr = ? and me_partgroup_partlst.partgroupid = ?", t.Finr,partgroupid)
		where = " left join me_partgroup_partlst on me_partgroup_partlst.finr = me_part.finr and me_partgroup_partlst.partid = me_part.partid and me_partgroup_partlst.projnr = me_part.projnr where me_part.finr = " + "'" + utils.ValueToString(t.Finr, " ") + "'" +" and me_partgroup_partlst.partgroupid = "+"'" + utils.ValueToString(partgroupid, "") + "'"
	}else{
		table = e.Table("me_part").Where("me_part.finr = ? ", t.Finr)
		where = "where me_part.finr = " + "'" + utils.ValueToString(t.Finr, "") + "'"
	}

	if t.Partid != "" {
		table = table.And("me_part.partid like '%" + t.Partid + "%'")
		where += " and me_part.partid like " + "'%" + utils.ValueToString(t.Partid, "") + "%'"
	}
	if !utils.ValueIsEmpty(projectid) {
		table = table.And("me_part.projnr = ?", projectid)
		where += " and me_part.projnr = " + "'" + utils.ValueToString(projectid, "") + "'"
	}

	if !utils.ValueIsEmpty(parts) {
		table = table.In("me_part.partid", parts)
		str := utils.IDsToStrings(parts)
		where += " and me_part.partid in (" + str + ")"
	}
	if ishide{
		table = table.And("me_part.status != 1")
		where += " and me_part.status != 1 "
	}
	Offset := (pageIndex - 1) * pageSize
	err = e.SQL("SELECT TOP " + utils.ValueToString(pageSize, "") + " me_part.* FROM me_part " + where + " AND (convert(varchar(10),me_part.finr)+convert(varchar(40),me_part.partid)+convert(varchar(40),me_part.projnr) NOT IN (SELECT TOP " + utils.ValueToString(Offset, "") + " convert(varchar(10),me_part.finr)+convert(varchar(40),me_part.partid)+convert(varchar(40),me_part.projnr) FROM me_part " + where + " ORDER BY me_part.projnr DESC)) ORDER BY me_part.projnr DESC").Find(&data)
	if err != nil {
		return nil, 0, err
	}
	pcount := new(MePart)
	count, err := table.Count(pcount)
	if err != nil {
		return nil, 0, err
	}
	var atcod MePartAtcodlst
	atcod.Finr = t.Finr
	atcod.Version = t.Version
	atc, err := atcod.SelectData()
	if err != nil {
		fmt.Printf("err is : %v", err)
		return nil, 0, err
	}
	tems := map[string]string{}
	for _, v := range atc {
		key := utils.ValueToString(v.Finr, "") + v.Partid + v.Projnr + utils.ValueToString(v.Attrcode, "")
		tems[key] = v.Attrvalue
	}

	for _, v := range data {
		v.Clipped()
		tem := map[string]interface{}{}
		tem["JCI part NO."] = v.Partid
		tem["Project No"] = v.Projnr
		tem["Description EN"] = v.Descr1
		tem["Description CN"] = v.Descr2

		temss := map[string]interface{}{}
		for _,vv:= range arr1{
			//第一步：先赋值
			key := utils.ValueToString(v.Finr, "") + v.Partid + v.Projnr + utils.ValueToString(vv.Attrcode, "")
			_,ok := tems[key]
			if ok {
				temss[vv.Attrname] = tems[key]
			}else{
				temss[vv.Attrname] = ""
			}
			tem["part"] = temss
		}
		dataMap = append(dataMap,tem)
	}
	return dataMap, int(count), nil
}

//保存
func (t *MePartAtcodlst) Save() error {
	e := db.Eloquent.Master()
	_, err := e.Table("me_part_atcodlst").Insert(t)
	if err != nil {
		return err
	}
	return nil
}

//删
func (t *MePartAtcodlst) Del() bool {
	e := db.Eloquent.Master()
	_, err := e.Table("me_part_atcodlst").Where("finr = ? and partid = ? and projnr = ? and version = ?", t.Finr, t.Partid, t.Projnr, t.Version).Delete(&MePartAtcodlst{})
	if err != nil {
		return false
	}
	return true
}

//excel表格导入数据库
func (t *MePartAtcodlst) ReadXlsx(path string) bool {
	//e := db.MasterEngine()

	xlsx, err := excelize.OpenFile(path)
	if err != nil {
		return false
	}
	rows := xlsx.GetRows("Sheet1")
	//定义一个数组，记录attrcode,并且与k关联起来
	tem := map[int]string{}
	for k, row := range rows {
		if k == 0 {
			//记录attrcode,并且与k关联起来
			for kk, vv := range row {
				tem[kk] = vv
			}
			continue
		}
		if k == 1 || k == 2 {
			continue
		}
		//初始化对象
		insertData := new(MePartAtcodlst)
		//版本号
		insertData.Version = t.Version
		//工厂号
		insertData.Finr = t.Finr
		//零件号
		insertData.Partid = row[0]
		//项目编号
		insertData.Projnr = row[1]
		//执行删除
		insertData.Del()
		for k, v := range row {
			//当列>=3开始记录零件属性
			if k >= 3 {
				//过滤数据
				if utils.ValueIsEmpty(v) {
					continue
				}
				//根据k的数值，映射数据
				val, ok := tem[k]
				//判断值是否存在
				if ok {
					insertData.Attrcode = utils.ValueToInt(val, 0)
					insertData.Attrvalue = v
					insertData.Lastuser = t.Lastuser
					insertData.Lastmodif = t.Lastmodif
					insertData.Credatuz = t.Credatuz
					err = insertData.Save()
					if err != nil {
						continue
					}

				}
			}

		}

	}
	return true
}

//根据零件名或者零件值，查询所有的零件
func (t *MePartAtcodlst) SelectParts() ([]string, error) {
	query := db.Eloquent.Master().Where("1=1").And("version = ?",t.Version)
	if t.Attrcode > 0 {
		query = query.And("attrcode = ?", t.Attrcode)
	}
	if t.Attrvalue != "" {
		query = query.And("attrvalue = ?", t.Attrvalue)
	}
	var data []MePartAtcodlst
	err := query.Find(&data)

	if err != nil {
		return nil, err
	}
	var strData []string
	for _, v := range data {
		v.Clipped()
		strData = append(strData, v.Partid)
	}
	return strData, nil
}
