package models

import (
	"LAPP_SJA_ME/db"
	"LAPP_SJA_ME/utils"
	"fmt"
)

//版本发布变更记录表
type MePartAtcodverTrace struct {
	Finr         int    `xorm:"pk comment('工厂号') int(0)" json:"me_part_atcodver_trace-finr"`
	Version      int    `xorm:"pk comment('版本号') int(0)" json:"me_part_atcodver_trace-version"`
	Pos          int    `xorm:"pk comment('属性值位置号') int(0)" json:"me_part_atcodver_trace-pos"`
	Partid       string `xorm:"comment('零件Id') VARCHAR(40)" json:"me_part_atcodver_trace-partid"`
	Type         string `xorm:"comment('变动类型:增，删，改') VARCHAR(10)" json:"me_part_atcodver_trace-type"`
	Projnr       string `xorm:"comment('项目Id') VARCHAR(40)" json:"me_part_atcodver_trace-projnr"`
	Attrcode     int    `xorm:"comment('属性ID') int(0)" json:"me_part_atcodver_trace-attrcode"`
	Attrvalue    string `xorm:"comment('属性值') VARCHAR(40)" json:"me_part_atcodver_trace-attrvalue"`
	Lastmodif    string `xorm:"comment('最近一次更改时间') VARCHAR(14)" json:"me_part_atcodver_trace-lastmodif"`
	Lastuser     string `xorm:"comment('最近一次更改人') VARCHAR(14)" json:"me_part_atcodver_trace-lastuser"`
	Credatuz     string `xorm:"comment('创建时间') VARCHAR(20)" json:"me_part_atcodver_trace-credatuz"`
	DescrPart    string `json:"me_part_atcodver_trace-descr_part" xorm:"-"`
	Attrname     string `json:"me_part_atcodver_trace-attrname" xorm:"-"`
	DescrVersion string `json:"me_part_atcodver_trace-descr_version" xorm:"-"`
	FromVersion  int    `json:"me_part_atcodver_trace-from_version" xorm:"-"`
}

type MePartAtcodverTraceAdd struct {
	Finr      int    `xorm:"pk comment('工厂号') int(0)" json:"me_part_atcodver_trace-finr"`
	Version   int    `xorm:"pk comment('版本号') int(0)" json:"me_part_atcodver_trace-version"`
	Partid    string `xorm:"comment('零件Id') VARCHAR(40)" json:"me_part_atcodver_trace-partid"`
	Type      string `xorm:"comment('变动类型:增，删，改') VARCHAR(10)" json:"me_part_atcodver_trace-type"`
	Projnr    string `xorm:"comment('项目Id') VARCHAR(40)" json:"me_part_atcodver_trace-projnr"`
	Attrcode  int    `xorm:"comment('属性ID') int(0)" json:"me_part_atcodver_trace-attrcode"`
	Attrvalue string `xorm:"comment('属性值') VARCHAR(40)" json:"me_part_atcodver_trace-attrvalue"`
	Lastmodif string `xorm:"comment('最近一次更改时间') VARCHAR(14)" json:"me_part_atcodver_trace-lastmodif"`
	Lastuser  string `xorm:"comment('最近一次更改人') VARCHAR(14)" json:"me_part_atcodver_trace-lastuser"`
	Credatuz  string `xorm:"comment('创建时间') VARCHAR(20)" json:"me_part_atcodver_trace-credatuz"`
}

type AtcodverTrace struct {
	MePartAtcodverTrace `xorm:"extends"`
	MePart              `xorm:"extends"`
	MePartAtcodver      `xorm:"extends"`
	MeAttribute         `xorm:"extends"`
}

func (t *MePartAtcodverTrace) TableName() string {
	return "me_part_atcodver_trace"
}

// 清除string字段的右侧空格
func (t *MePartAtcodverTrace) Clipped() {
	utils.TrimStruct(t, *t)
}

//查询列表
func (t *MePartAtcodverTrace) GetPage(pageSize int, pageIndex int) ([]MePartAtcodverTrace, int, error) {
	data := make([]AtcodverTrace, 0)
	datalist := make([]MePartAtcodverTrace, 0)
	e := db.Eloquent.Master()
	table := e.Table("me_part_atcodver_trace").Where("finr = ? ", t.Finr)
	where := " left join me_attribute on me_attribute.attrcode = me_part_atcodver_trace.attrcode and me_attribute.finr = me_part_atcodver_trace.finr left join me_part on me_part.partid = me_part_atcodver_trace.partid and me_part.projnr = me_part_atcodver_trace.projnr left join me_part_atcodver on me_part_atcodver.version = me_part_atcodver_trace.version where me_part_atcodver_trace.finr = " + "'" + utils.ValueToString(t.Finr, "") + "'"

	if t.Partid != "" {
		table = table.And("partid = ?", t.Partid)
		where += " and me_part_atcodver_trace.partid = " + "'" + utils.ValueToString(t.Partid, "") + "'"
	}
	if t.Version > 0 {
		table = table.And("version = ?", t.Version)
		where += " and me_part_atcodver_trace.version = " + "'" + utils.ValueToString(t.Version, "") + "'"
	}
	Offset := (pageIndex - 1) * pageSize
	err := e.SQL("SELECT TOP " + utils.ValueToString(pageSize, "") + " me_part_atcodver_trace.*, me_part.*, me_part_atcodver.*,me_attribute.* FROM me_part_atcodver_trace " + where + " AND (convert(varchar(10),me_part_atcodver_trace.finr)+convert(varchar(40),me_part_atcodver_trace.version)+convert(varchar(10),me_part_atcodver_trace.pos) NOT IN (SELECT TOP " + utils.ValueToString(Offset, "") + " convert(varchar(10),me_part_atcodver_trace.finr)+convert(varchar(40),me_part_atcodver_trace.version)+convert(varchar(10),me_part_atcodver_trace.pos) FROM me_part_atcodver_trace " + where + " ORDER BY me_part_atcodver_trace.version DESC)) ORDER BY me_part_atcodver_trace.version DESC").Find(&data)
	if err != nil {
		fmt.Printf("err is :%v", err)
	}
	pcount := new(MePartAtcodverTrace)
	count, err := table.Count(pcount)
	if err != nil {
		return nil, 0, err
	}
	for _, v := range data {
		v.MePartAtcodver.Clipped()
		v.MeAttribute.Clipped()
		v.MePart.Clipped()
		v.MePartAtcodverTrace.Clipped()
		dataone := MePartAtcodverTrace{}
		dataone = v.MePartAtcodverTrace
		dataone.DescrPart = v.MePart.Descr2
		dataone.Attrname = v.MeAttribute.Attrname
		dataone.DescrVersion = v.MePartAtcodver.Descr
		dataone.FromVersion = v.MePartAtcodver.Fromversion
		datalist = append(datalist, dataone)
	}
	return datalist, int(count), nil
}

//添加变动信息
func (t *MePartAtcodverTrace) Add() error {
	e := db.Eloquent.Master()
	m := new(MePartAtcodverTraceAdd)
	m.Finr = t.Finr
	m.Version = t.Version
	m.Projnr = t.Projnr
	m.Type = t.Type
	m.Partid = t.Partid
	m.Attrcode = t.Attrcode
	m.Attrvalue = t.Attrvalue
	m.Credatuz = t.Credatuz
	m.Lastuser = t.Lastuser
	m.Lastmodif = t.Lastmodif
	_, err := e.Table("me_part_atcodver_trace").Insert(m)
	if err != nil {
		return err
	}
	return nil
}

/****
*判断添加信息
*Adata :改变前的数据
*Bdata :改变后的数据
*逻辑：根据集合求出，增，删，改
*******/
func (t *MePartAtcodverTrace) SelectAdd(Adata []MePartAtcodlst, Bdata []MePartAtcodlst) bool {
	//构建数据
	var Astring []string
	Adatatem := map[string]MePartAtcodlst{}
	for _, v := range Adata {
		key := utils.ValueToString(v.Finr, "") + "_" + utils.ValueToString(v.Version, "") + "_" + v.Projnr + "_" + v.Partid + "_" + utils.ValueToString(v.Attrcode, "")
		Astring = append(Astring, key)
		Adatatem[key] = v
	}
	//构建数据
	var Bstring []string
	Bdatatem := map[string]MePartAtcodlst{}
	for _, v := range Bdata {
		key := utils.ValueToString(v.Finr, "") + "_" + utils.ValueToString(v.Version, "") + "_" + v.Projnr + "_" + v.Partid + "_" + utils.ValueToString(v.Attrcode, "")
		Bstring = append(Bstring, key)
		Bdatatem[key] = v
	}
	//删除（A-B差集）
	diffAB := utils.Difference(Astring, Bstring)
	dataAB := returnData(diffAB, Adatatem)
	for _, v := range dataAB {
		m := new(MePartAtcodverTrace)
		m.Finr = v.Finr
		m.Version = v.Version
		m.Partid = v.Partid
		m.Projnr = v.Projnr
		m.Attrvalue = v.Attrvalue
		m.Attrcode = v.Attrcode
		m.Type = "del"
		m.Lastuser = t.Lastuser
		m.Lastmodif = t.Lastmodif
		m.Credatuz = t.Credatuz
		err := m.Add()
		if err != nil {
			continue
		}
	}
	//增加（B-A差集）
	diffBA := utils.Difference(Bstring, Astring)
	dataBA := returnData(diffBA, Bdatatem)

	for _, v := range dataBA {
		m := new(MePartAtcodverTrace)
		m.Finr = v.Finr
		m.Version = v.Version
		m.Partid = v.Partid
		m.Projnr = v.Projnr
		m.Attrvalue = v.Attrvalue
		m.Attrcode = v.Attrcode
		m.Type = "add"
		m.Lastuser = t.Lastuser
		m.Lastmodif = t.Lastmodif
		m.Credatuz = t.Credatuz
		err := m.Add()
		if err != nil {
			continue
		}
	}
	//修改，需要对比值有没有变化（A&B交集）
	IntersectAB := utils.Intersect(Astring, Bstring)
	dataIn := returnData(IntersectAB, Adatatem)

	for k, v := range dataIn {
		//当值不等的话即为修改
		if Adatatem[k].Attrvalue != Bdatatem[k].Attrvalue {
			m := new(MePartAtcodverTrace)
			m.Finr = v.Finr
			m.Version = v.Version
			m.Partid = v.Partid
			m.Projnr = v.Projnr
			m.Attrvalue = v.Attrvalue
			m.Attrcode = v.Attrcode
			m.Type = "edit"
			m.Lastuser = t.Lastuser
			m.Lastmodif = t.Lastmodif
			m.Credatuz = t.Credatuz
			err := m.Add()
			if err != nil {
				continue
			}
		}

	}
	return true
}

//筛选出存在的key值
func returnData(sdata []string, data map[string]MePartAtcodlst) map[string]MePartAtcodlst {
	datatem := map[string]MePartAtcodlst{}
	for _, v := range sdata {
		val, ok := data[v]
		if ok {
			key := utils.ValueToString(v, "")
			datatem[key] = val
		}
	}
	return datatem
}
