package models

import (
	"LAPP_SJA_ME/db"
	"LAPP_SJA_ME/utils"
)

// 项目对象
type MeProject struct {
	Finr                            int    `xorm:"pk" json:"me_project-finr"`
	Projectid                       string `xorm:"pk" json:"me_project-projectid"`
	Descr                           string `xorm:"comment('描述') VARCHAR(40)" json:"me_project-descr"`
	Enabled                         int    `xorm:"comment('tod')" json:"me_project-enabled"`
	Plantsitecode                   int    `xorm:"comment('tod')" json:"me_project-plantsitecode"`
	Parse_tod                       int    `xorm:"comment('tod')" json:"me_project-parse_tod"`
	Parse_seq                       int    `xorm:"comment('seq')" json:"me_project-parse_seq"`
	Parse_reorder                   int    `xorm:"comment('seq')" json:"me_project-parse_reorder"`
	Parse_calloff                   int    `xorm:"comment('seq')" json:"me_project-parse_calloff"`
	Fileserver_host                 string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-fileserver_host"`
	Tod_folder                      string `xorm:"comment('名称') VARCHAR(150)" json:"me_project-tod_folder"`
	Seq_folder                      string `xorm:"comment('名称') VARCHAR(150)" json:"me_project-seq_folder"`
	Reorder_folder                  string `xorm:"comment('名称') VARCHAR(150)" json:"me_project-reorder_folder"`
	Calloff_folder                  string `xorm:"comment('名称') VARCHAR(150)" json:"me_project-calloff_folder"`
	Tod_filename_regexp             string `xorm:"comment('是否共用字段') VARCHAR(150)" json:"me_project-tod_filename_regexp"`
	Seq_filename_regexp             string `xorm:"comment('是否共用字段') VARCHAR(150)" json:"me_project-seq_filename_regexp"`
	Reorder_filename_regexp         string `xorm:"comment('是否共用字段') VARCHAR(150)" json:"me_project-reorder_filename_regexp"`
	Calloff_filename_regexp         string `xorm:"comment('是否共用字段') VARCHAR(150)" json:"me_project-calloff_filename_regexp"`
	Tod_verify_part                 int    `xorm:"comment('是否共用字段') int(0)" json:"me_project-tod_verify_part"`
	Tod_verify_partfamily           int    `xorm:"comment('是否共用字段') int(0)" json:"me_project-tod_verify_partfamily"`
	Tod_verify_supplygroup          int    `xorm:"comment('是否共用字段') int(0)" json:"me_project-tod_verify_supplygroup"`
	Tod_verify_partfamilyattribute  int    `xorm:"comment('是否共用字段') int(0)" json:"me_project-tod_verify_partfamilyattribute"`
	Tod_verify_supplygroupattribute int    `xorm:"comment('是否共用字段') int(0)" json:"me_project-tod_verify_supplygroupattribute"`
	Seq_verify_sequence             int    `xorm:"comment('是否共用字段') int(0)" json:"me_project-seq_verify_sequence"`
	Seq_verfiy_partfamily           string `xorm:"comment('是否共用字段') VARCHAR(60)" json:"me_project-seq_verfiy_partfamily"`
	Seq_verify_carmodelattribute    int    `xorm:"comment('是否共用字段') int(0)" json:"me_project-seq_verify_carmodelattribute"`
	Reorder_email_alert             int    `xorm:"comment('是否共用字段') int(0)" json:"me_project-reorder_email_alert"`
	Calloff_verify_checksequence    int    `xorm:"comment('是否共用字段') int(0)" json:"me_project-calloff_verify_checksequence"`
	Calloff_verify_orderstatus      int    `xorm:"comment('是否共用字段') int(0)" json:"me_project-calloff_verify_orderstatus"`
	Calloff_verify_orderspec        int    `xorm:"comment('是否共用字段') int(0)" json:"me_project-calloff_verify_orderspec"`
	Emailserver_host                string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-emailserver_host"`
	Emailserver_port                int    `xorm:"comment('是否共用字段') int(0)" json:"me_project-emailserver_port"`
	From_email                      string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-from_email"`
	From_pwd                        string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-from_pwd"`
	Tod_error_to_recievers          string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-tod_error_cc_recievers"`
	Tod_error_cc_recievers          string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-tod_error_cc_recievers"`
	Seq_error_to_recievers          string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-seq_error_to_recievers"`
	Seq_error_cc_recievers          string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-seq_error_cc_recievers"`
	Reorder_picktemplateid          string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-reorder_picktemplateid"`
	Reorder_pickorder_snr           string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-reorder_pickorder_snr"`
	Reorder_error_to_recievers      string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-reorder_error_to_recievers"`
	Reorder_error_cc_recievers      string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-reorder_error_cc_recievers"`
	Calloff_error_to_recievers      string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-calloff_error_to_recievers"`
	Calloff_error_cc_recievers      string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-calloff_error_cc_recievers"`
	Log_url                         string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-log_url"`
	Log_table                       string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-log_table"`
	Custorder_snr                   string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-custorder_snr"`
	Workorder_snr                   string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-workorder_snr"`
	Manualwo_snr                    string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-manualwo_snr"`
	Ordermsg_snr                    string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-ordermsg_snr"`
	Reorder_snr                     string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-reorder_snr"`
	Shippack_snr                    string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-shippack_snr"`
	Shippacksync_snr                string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-shippacksync_snr"`
	Shipcar_snr                     string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-shipcar_snr"`
	Asn_file_prefix                 string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-asn_file_prefix"`
	Asn_snr                         string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-asn_snr"`
	Asn_pfmapper                    string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-asn_pfmapper"`
	Asn_file_type                   string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-asn_file_type"`
	Asn_folder                      string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-asn_folder"`
	Backflush_folder                string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-backflush_folder"`
	Shipfile_folder                 string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-shipfile_folder"`
	Tier2_folder                    string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-tier2_folder"`
	Shipfile_snr                    string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-shipfile_snr"`
	Lastmodif                       string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-lastmodif"`
	Lastuser                        string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-lastuser"`
	Credatuz                        string `xorm:"comment('名称') VARCHAR(60)" json:"me_project-credatuz"`
}

func (t *MeProject) TableName() string {
	return "me_project"
}

// 清除string字段的右侧空格
func (t *MeProject) Clipped() {
	utils.TrimStruct(t, *t)
}

//查
func (t *MeProject) SelectAll() ([]MeProject, error) {
	e := db.Eloquent.Master()

	var data []MeProject
	err := e.Where("finr = ? ", t.Finr).Find(&data)
	if err != nil {
		return data, err
	}
	for k, _ := range data {
		data[k].Clipped()
	}
	return data, nil
}
