package models

import (
	"LAPP_SJA_ME/db"
	"LAPP_SJA_ME/utils"
)

type PlnForecastCalendarDaylst struct {
	Finr       int     `xorm:"pk comment('工厂号') Int" json:"pln_forecast_calendar_daylst-finr"`
	Calendarid string  `xorm:"pk comment('工作日历ID') VARCHAR(20)" json:"pln_forecast_calendar_daylst-calendarid"`
	Caldate    string  `xorm:"comment('开始日期')  VARCHAR(20)" json:"pln_forecast_calendar_daylst-caldate"`
	Effactor   float64 `xorm:"comment('工作效率')  VARCHAR(8)" json:"pln_forecast_calendar_daylst-effactor"`
	Lastmodif  string  `xorm:"comment('最近一次更改时间') VARCHAR(14)" json:"pln_forecast_calendar_daylst-lastmodif"`
	Lastuser   string  `xorm:"comment('最近一次更改人') VARCHAR(20)" json:"pln_forecast_calendar_daylst-lastuser"`
	Credatuz   string  `xorm:"comment('创建时间') VARCHAR(14)" json:"pln_forecast_calendar_daylst-credatuz"`
}

func (t *PlnForecastCalendarDaylst) TableName() string {
	return "pln_forecast_calendar_daylst"
}

// 清除string字段的右侧空格
func (t *PlnForecastCalendarDaylst) Clipped() {
	utils.TrimStruct(t, *t)
}

//统计求和
func (t *PlnForecastCalendarDaylst) SumEfffactor(first string, last string) (total float64, err error) {
	e := db.Eloquent.Master()
	total, err = e.Where("finr = ? and calendarid = ? and caldate>= ? and caldate<= ?", t.Finr, t.Calendarid, first, last).Sum(t, "effactor")
	if err != nil {
		return 0.0, err
	}
	return total, nil
}
